package com.example.what_the_fantasy.ui.viewModels

import android.util.Log
import androidx.lifecycle.ViewModel
import com.example.what_the_fantasy.data.services.ServicesStub
import com.example.what_the_fantasy.ui.states.QuoteInformationUserState
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.StateFlow
import kotlinx.coroutines.flow.asStateFlow
import kotlinx.coroutines.flow.update

class QuoteInformationUserViewModel: ViewModel() {
    private val services = ServicesStub() // faire repository qui gère les services Stub et API
    private val _quoteState = MutableStateFlow(QuoteInformationUserState())
    val quoteState : StateFlow<QuoteInformationUserState> = _quoteState.asStateFlow()

    fun setComment(comment : String){
        _quoteState.update { it.copy(comment=comment) }
    }

    fun setFavorite(isFavorite : Boolean){
        _quoteState.update { it.copy(isFavorite=isFavorite) }
    }

    fun setLike(like : Int){
        if(like >= 0) {
            _quoteState.update { it.copy(like=like) }
        }
    }

   fun addFav(userId: Int, idQuote: Int) {
       services.AddFav(userId, idQuote)
       setLike(quoteState.value.like + 1)
       setFavorite(true)
    }

    fun supFav(userId: Int, idQuote: Int) {
        services.SupFav(userId, idQuote)
        setLike(quoteState.value.like - 1)
        setFavorite(false)
        //Log.e("Like", "Service ${quoteState.value.like}")
    }
}